package AStar_Prog;

public class GraphNode implements Comparable<GraphNode>{

	private int x;
	private int y;
	private double fitness;
	private double distanceToPlayer = 99999;
	
	private GraphNode home = null;
	private GraphNode north = null;
	private GraphNode south = null;
	private GraphNode west = null;
	private GraphNode east = null;
	
	
	
	public GraphNode(int x, int y) {
		
		this.x = x;
		this.y = y;
		calculateFitness();
		
	}
	
	public void reset(){
		
		  home = null;
		
		distanceToPlayer = 99999;
		calculateFitness();
		
		
	}
	
	
	public GraphNode getNorth() {
		return north;
	}

	public void setNorth(GraphNode north) {
		this.north = north;
	}

	public GraphNode getSouth() {
		return south;
	}

	public void setSouth(GraphNode south) {
		this.south = south;
	}

	public GraphNode getWest() {
		return west;
	}

	public void setWest(GraphNode west) {
		this.west = west;
	}

	public GraphNode getEast() {
		return east;
	}

	public void setEast(GraphNode east) {
		this.east = east;
	}

	public void setHome(GraphNode home){
		this.home = home;
	}
	
	public GraphNode getHome() {
		return home;
	}
	
	public boolean isValid(){
//		System.out.println("X:"+x+" Y:"+y);
//		System.out.println(!(Main.mySquares[x][y] == 3));
		if (Map.getMap()[x][y] == 3)
			return false;
		else
			return true;
	}
	
		public void calculateFitness(){			
			fitness = distanceToPlayer + estimateDistanceToTarget();
		}
	
	public void setDistance(double distance){
				distanceToPlayer = distance;
	}

	public double getDistance(){
		return distanceToPlayer;
}
	
	public void calculateDistance(){
		distanceToPlayer = 1 + home.distanceToPlayer;
	}
	
	public double getFitness(){
		return fitness;
	}
	
	public boolean isNode(int x, int y) {
		if (this.x == x && this.y == y)
			return true;
		else
			return false;
	}
	
	public int getX() {
		return x;
	}

	public int getY() {
		return y;
	}
	
	public double estimateDistanceToTarget() {
		
		int targetX = Map.getTargetX();
		int targetY = Map.getTargetY();
		return Math.sqrt((double) ((targetX-x)*(targetX-x) + (targetY-y)*(targetY-y)));
	}




	@Override
	public int compareTo(GraphNode node) {
		if (fitness == node.getFitness())
		return 0;
		else if (fitness > node.getFitness())
			return 1;
		else
			return -1;
	}
	
	
	public void printNode(){
		System.out.println("This: " + this.getX() + this.getY());
		System.out.println("East: " + east + "\t West: " + west + "\t North: " + north + "\t South: " + south);
	}
	
}